enums.h File Reference

GPU enumeration values. More...

Go to the source code of this file.

## Macros

#define | GPU_TEXTURE_MAG_FILTER(v) (((v)&0x1)<<1)
| Creates a texture magnification filter parameter from a GPU_TEXTURE_FILTER_PARAM.
#define | GPU_TEXTURE_MIN_FILTER(v) (((v)&0x1)<<2)
| Creates a texture minification filter parameter from a GPU_TEXTURE_FILTER_PARAM.
#define | GPU_TEXTURE_MIP_FILTER(v) (((v)&0x1)<<24)
| Creates a texture mipmap filter parameter from a GPU_TEXTURE_FILTER_PARAM.
#define | GPU_TEXTURE_WRAP_S(v) (((v)&0x3)<<12)
| Creates a texture wrap S parameter from a GPU_TEXTURE_WRAP_PARAM.
#define | GPU_TEXTURE_WRAP_T(v) (((v)&0x3)<<8)
| Creates a texture wrap T parameter from a GPU_TEXTURE_WRAP_PARAM.
#define | GPU_TEXTURE_MODE(v) (((v)&0x7)<<28)
| Creates a texture mode parameter from a GPU_TEXTURE_MODE_PARAM.
#define | GPU_TEXTURE_ETC1_PARAM BIT(5)
| Texture parameter indicating ETC1 texture.
#define | GPU_TEXTURE_SHADOW_PARAM BIT(20)
| Texture parameter indicating shadow texture.
#define | GPU_TEV_BUFFER_WRITE_CONFIG(stage0, stage1, stage2, stage3) ((stage0) | ((stage1) << 1) | ((stage2) << 2) | ((stage3) << 3))
| Creates a combiner buffer write configuration.
#define | GPU_MAKEGASDEPTHFUNC(n) (GPU_GASDEPTHFUNC)((0xAF02>>((int)(n)<<1))&3)
| Converts GPU_TESTFUNC into GPU_GASDEPTHFUNC.
#define | GPU_ATTRIBFMT(i, n, f) (((((n)-1)<<2)|((f)&3))<<((i)*4))
| Creates a VBO attribute parameter from its index, size, and format.
#define | GPU_TEVSOURCES(a, b, c) (((a))|((b)<<4)|((c)<<8))
| Creates a texture combiner source parameter from three sources.
#define | GPU_TEVOPERANDS(a, b, c) (((a))|((b)<<4)|((c)<<8))
| Creates a texture combiner operand parameter from three operands.
#define | GPU_LIGHT_ENV_LAYER_CONFIG(n) ((n)+((n)==7))
| Creates a light environment layer configuration parameter.
#define | GPU_LC1_SHADOWBIT(n) BIT(n)
| Light shadow disable bits in GPUREG_LIGHT_CONFIG1.
#define | GPU_LC1_SPOTBIT(n) BIT((n)+8)
| Light spot disable bits in GPUREG_LIGHT_CONFIG1.
#define | GPU_LC1_LUTBIT(n) BIT((n)+16)
| LUT disable bits in GPUREG_LIGHT_CONFIG1.
#define | GPU_LC1_ATTNBIT(n) BIT((n)+24)
| Light distance attenuation disable bits in GPUREG_LIGHT_CONFIG1.
#define | GPU_LIGHTPERM(i, n) ((n) << ((i)*4))
| Creates a light permutation parameter.
#define | GPU_LIGHTLUTINPUT(i, n) ((n) << ((i)*4))
| Creates a light LUT input parameter.
#define | GPU_LIGHTLUTIDX(c, i, o) ((o) | ((i) << 8) | ((c) << 11))
| Creates a light LUT index parameter.
#define | GPU_LIGHTCOLOR(r, g, b) (((b) & 0xFF) | (((g) << 10) & 0xFF) | (((r) << 20) & 0xFF))
| Creates a light color parameter from red, green, and blue components.

## Enumerations

enum | GPU_TEXTURE_FILTER_PARAM { GPU_NEAREST = 0x0 , GPU_LINEAR = 0x1 }
| Texture filters. More...
enum | GPU_TEXTURE_WRAP_PARAM { GPU_CLAMP_TO_EDGE = 0x0 , GPU_CLAMP_TO_BORDER = 0x1 , GPU_REPEAT = 0x2 , GPU_MIRRORED_REPEAT = 0x3 }
| Texture wrap modes. More...
enum | GPU_TEXTURE_MODE_PARAM { GPU_TEX_2D = 0x0 , GPU_TEX_CUBE_MAP = 0x1 , GPU_TEX_SHADOW_2D = 0x2 , GPU_TEX_PROJECTION = 0x3 , GPU_TEX_SHADOW_CUBE = 0x4 , GPU_TEX_DISABLED = 0x5 }
| Texture modes. More...
enum | GPU_TEXUNIT { GPU_TEXUNIT0 = 0x1 , GPU_TEXUNIT1 = 0x2 , GPU_TEXUNIT2 = 0x4 }
| Supported texture units. More...
enum | GPU_TEXCOLOR { GPU_RGBA8 = 0x0 , GPU_RGB8 = 0x1 , GPU_RGBA5551 = 0x2 , GPU_RGB565 = 0x3 , GPU_RGBA4 = 0x4 , GPU_LA8 = 0x5 , GPU_HILO8 = 0x6 , GPU_L8 = 0x7 , GPU_A8 = 0x8 , GPU_LA4 = 0x9 , GPU_L4 = 0xA , GPU_A4 = 0xB , GPU_ETC1 = 0xC , GPU_ETC1A4 = 0xD }
| Supported texture formats. More...
enum | GPU_TEXFACE { GPU_TEXFACE_2D = 0 , GPU_POSITIVE_X = 0 , GPU_NEGATIVE_X = 1 , GPU_POSITIVE_Y = 2 , GPU_NEGATIVE_Y = 3 , GPU_POSITIVE_Z = 4 , GPU_NEGATIVE_Z = 5 }
| Texture faces. More...
enum | GPU_PROCTEX_CLAMP { GPU_PT_CLAMP_TO_ZERO = 0 , GPU_PT_CLAMP_TO_EDGE = 1 , GPU_PT_REPEAT = 2 , GPU_PT_MIRRORED_REPEAT = 3 , GPU_PT_PULSE = 4 }
| Procedural texture clamp modes. More...
enum | GPU_PROCTEX_MAPFUNC { GPU_PT_U = 0 , GPU_PT_U2 = 1 , GPU_PT_V = 2 , GPU_PT_V2 = 3 , GPU_PT_ADD = 4 , GPU_PT_ADD2 = 5 , GPU_PT_SQRT2 = 6 , GPU_PT_MIN = 7 , GPU_PT_MAX = 8 , GPU_PT_RMAX = 9 }
| Procedural texture mapping functions. More...
enum | GPU_PROCTEX_SHIFT { GPU_PT_NONE = 0 , GPU_PT_ODD = 1 , GPU_PT_EVEN = 2 }
| Procedural texture shift values. More...
enum | GPU_PROCTEX_FILTER { GPU_PT_NEAREST = 0 , GPU_PT_LINEAR = 1 , GPU_PT_NEAREST_MIP_NEAREST = 2 , GPU_PT_LINEAR_MIP_NEAREST = 3 , GPU_PT_NEAREST_MIP_LINEAR = 4 , GPU_PT_LINEAR_MIP_LINEAR = 5 }
| Procedural texture filter values. More...
enum | GPU_PROCTEX_LUTID { GPU_LUT_NOISE = 0 , GPU_LUT_RGBMAP = 2 , GPU_LUT_ALPHAMAP = 3 , GPU_LUT_COLOR = 4 , GPU_LUT_COLORDIF = 5 }
| Procedural texture LUT IDs. More...
enum | GPU_COLORBUF { GPU_RB_RGBA8 = 0 , GPU_RB_RGB8 = 1 , GPU_RB_RGBA5551 = 2 , GPU_RB_RGB565 = 3 , GPU_RB_RGBA4 = 4 }
| Supported color buffer formats. More...
enum | GPU_DEPTHBUF { GPU_RB_DEPTH16 = 0 , GPU_RB_DEPTH24 = 2 , GPU_RB_DEPTH24_STENCIL8 = 3 }
| Supported depth buffer formats. More...
enum | GPU_TESTFUNC { GPU_NEVER = 0 , GPU_ALWAYS = 1 , GPU_EQUAL = 2 , GPU_NOTEQUAL = 3 , GPU_LESS = 4 , GPU_LEQUAL = 5 , GPU_GREATER = 6 , GPU_GEQUAL = 7 }
| Test functions. More...
enum | GPU_EARLYDEPTHFUNC { GPU_EARLYDEPTH_GEQUAL = 0 , GPU_EARLYDEPTH_GREATER = 1 , GPU_EARLYDEPTH_LEQUAL = 2 , GPU_EARLYDEPTH_LESS = 3 }
| Early depth test functions. More...
enum | GPU_GASDEPTHFUNC { GPU_GAS_NEVER = 0 , GPU_GAS_ALWAYS = 1 , GPU_GAS_GREATER = 2 , GPU_GAS_LESS = 3 }
| Gas depth functions. More...
enum | GPU_SCISSORMODE { GPU_SCISSOR_DISABLE = 0 , GPU_SCISSOR_INVERT = 1 , GPU_SCISSOR_NORMAL = 3 }
| Scissor test modes. More...
enum | GPU_STENCILOP { GPU_STENCIL_KEEP = 0 , GPU_STENCIL_ZERO = 1 , GPU_STENCIL_REPLACE = 2 , GPU_STENCIL_INCR = 3 , GPU_STENCIL_DECR = 4 , GPU_STENCIL_INVERT = 5 , GPU_STENCIL_INCR_WRAP = 6 , GPU_STENCIL_DECR_WRAP = 7 }
| Stencil operations. More...
enum | GPU_WRITEMASK { GPU_WRITE_RED = 0x01 , GPU_WRITE_GREEN = 0x02 , GPU_WRITE_BLUE = 0x04 , GPU_WRITE_ALPHA = 0x08 , GPU_WRITE_DEPTH = 0x10 , GPU_WRITE_COLOR = 0x0F , GPU_WRITE_ALL = 0x1F }
| Pixel write mask. More...
enum | GPU_BLENDEQUATION { GPU_BLEND_ADD = 0 , GPU_BLEND_SUBTRACT = 1 , GPU_BLEND_REVERSE_SUBTRACT = 2 , GPU_BLEND_MIN = 3 , GPU_BLEND_MAX = 4 }
| Blend modes. More...

enum

GPU_BLENDFACTOR {
GPU_ZERO = 0 ,
GPU_ONE = 1 ,
GPU_SRC_COLOR = 2 ,
GPU_ONE_MINUS_SRC_COLOR = 3 ,
GPU_DST_COLOR = 4 ,
GPU_ONE_MINUS_DST_COLOR = 5 ,
GPU_SRC_ALPHA = 6 ,
GPU_ONE_MINUS_SRC_ALPHA = 7 ,
GPU_DST_ALPHA = 8 ,
GPU_ONE_MINUS_DST_ALPHA = 9 ,
GPU_CONSTANT_COLOR = 10 ,
GPU_ONE_MINUS_CONSTANT_COLOR = 11 ,
GPU_CONSTANT_ALPHA = 12 ,
GPU_ONE_MINUS_CONSTANT_ALPHA = 13 ,
GPU_SRC_ALPHA_SATURATE = 14
}

| Blend factors. More...

enum

GPU_LOGICOP {
GPU_LOGICOP_CLEAR = 0 ,
GPU_LOGICOP_AND = 1 ,
GPU_LOGICOP_AND_REVERSE = 2 ,
GPU_LOGICOP_COPY = 3 ,
GPU_LOGICOP_SET = 4 ,
GPU_LOGICOP_COPY_INVERTED = 5 ,
GPU_LOGICOP_NOOP = 6 ,
GPU_LOGICOP_INVERT = 7 ,
GPU_LOGICOP_NAND = 8 ,
GPU_LOGICOP_OR = 9 ,
GPU_LOGICOP_NOR = 10 ,
GPU_LOGICOP_XOR = 11 ,
GPU_LOGICOP_EQUIV = 12 ,
GPU_LOGICOP_AND_INVERTED = 13 ,
GPU_LOGICOP_OR_REVERSE = 14 ,
GPU_LOGICOP_OR_INVERTED = 15
}

| Logical operations. More...
enum | GPU_FRAGOPMODE { GPU_FRAGOPMODE_GL = 0 , GPU_FRAGOPMODE_GAS_ACC = 1 , GPU_FRAGOPMODE_SHADOW = 3 }
| Fragment operation modes. More...
enum | GPU_FORMATS { GPU_BYTE = 0 , GPU_UNSIGNED_BYTE = 1 , GPU_SHORT = 2 , GPU_FLOAT = 3 }
| Supported component formats. More...
enum | GPU_CULLMODE { GPU_CULL_NONE = 0 , GPU_CULL_FRONT_CCW = 1 , GPU_CULL_BACK_CCW = 2 }
| Cull modes. More...
enum | GPU_TEVSRC { GPU_PRIMARY_COLOR = 0x00 , GPU_FRAGMENT_PRIMARY_COLOR = 0x01 , GPU_FRAGMENT_SECONDARY_COLOR = 0x02 , GPU_TEXTURE0 = 0x03 , GPU_TEXTURE1 = 0x04 , GPU_TEXTURE2 = 0x05 , GPU_TEXTURE3 = 0x06 , GPU_PREVIOUS_BUFFER = 0x0D , GPU_CONSTANT = 0x0E , GPU_PREVIOUS = 0x0F }
| Texture combiner sources. More...

enum

GPU_TEVOP_RGB {
GPU_TEVOP_RGB_SRC_COLOR = 0x00 ,
GPU_TEVOP_RGB_ONE_MINUS_SRC_COLOR = 0x01 ,
GPU_TEVOP_RGB_SRC_ALPHA = 0x02 ,
GPU_TEVOP_RGB_ONE_MINUS_SRC_ALPHA = 0x03 ,
GPU_TEVOP_RGB_SRC_R = 0x04 ,
GPU_TEVOP_RGB_ONE_MINUS_SRC_R = 0x05 ,
GPU_TEVOP_RGB_0x06 = 0x06 ,
GPU_TEVOP_RGB_0x07 = 0x07 ,
GPU_TEVOP_RGB_SRC_G = 0x08 ,
GPU_TEVOP_RGB_ONE_MINUS_SRC_G = 0x09 ,
GPU_TEVOP_RGB_0x0A = 0x0A ,
GPU_TEVOP_RGB_0x0B = 0x0B ,
GPU_TEVOP_RGB_SRC_B = 0x0C ,
GPU_TEVOP_RGB_ONE_MINUS_SRC_B = 0x0D ,
GPU_TEVOP_RGB_0x0E = 0x0E ,
GPU_TEVOP_RGB_0x0F = 0x0F
}

| Texture RGB combiner operands. More...
enum | GPU_TEVOP_A { GPU_TEVOP_A_SRC_ALPHA = 0x00 , GPU_TEVOP_A_ONE_MINUS_SRC_ALPHA = 0x01 , GPU_TEVOP_A_SRC_R = 0x02 , GPU_TEVOP_A_ONE_MINUS_SRC_R = 0x03 , GPU_TEVOP_A_SRC_G = 0x04 , GPU_TEVOP_A_ONE_MINUS_SRC_G = 0x05 , GPU_TEVOP_A_SRC_B = 0x06 , GPU_TEVOP_A_ONE_MINUS_SRC_B = 0x07 }
| Texture Alpha combiner operands. More...
enum | GPU_COMBINEFUNC { GPU_REPLACE = 0x00 , GPU_MODULATE = 0x01 , GPU_ADD = 0x02 , GPU_ADD_SIGNED = 0x03 , GPU_INTERPOLATE = 0x04 , GPU_SUBTRACT = 0x05 , GPU_DOT3_RGB = 0x06 , GPU_DOT3_RGBA = 0x07 , GPU_MULTIPLY_ADD = 0x08 , GPU_ADD_MULTIPLY = 0x09 }
| Texture combiner functions. More...
enum | GPU_TEVSCALE { GPU_TEVSCALE_1 = 0x0 , GPU_TEVSCALE_2 = 0x1 , GPU_TEVSCALE_4 = 0x2 }
| Texture scale factors. More...
enum | GPU_FRESNELSEL { GPU_NO_FRESNEL = 0 , GPU_PRI_ALPHA_FRESNEL = 1 , GPU_SEC_ALPHA_FRESNEL = 2 , GPU_PRI_SEC_ALPHA_FRESNEL = 3 }
| Fresnel options. More...
enum | GPU_BUMPMODE { GPU_BUMP_NOT_USED = 0 , GPU_BUMP_AS_BUMP = 1 , GPU_BUMP_AS_TANG = 2 }
| Bump map modes. More...
enum | GPU_LIGHTLUTID { GPU_LUT_D0 = 0 , GPU_LUT_D1 = 1 , GPU_LUT_SP = 2 , GPU_LUT_FR = 3 , GPU_LUT_RB = 4 , GPU_LUT_RG = 5 , GPU_LUT_RR = 6 , GPU_LUT_DA = 7 }
| LUT IDs. More...
enum | GPU_LIGHTLUTINPUT { GPU_LUTINPUT_NH = 0 , GPU_LUTINPUT_VH = 1 , GPU_LUTINPUT_NV = 2 , GPU_LUTINPUT_LN = 3 , GPU_LUTINPUT_SP = 4 , GPU_LUTINPUT_CP = 5 }
| LUT inputs. More...
enum | GPU_LIGHTLUTSCALER { GPU_LUTSCALER_1x = 0 , GPU_LUTSCALER_2x = 1 , GPU_LUTSCALER_4x = 2 , GPU_LUTSCALER_8x = 3 , GPU_LUTSCALER_0_25x = 6 , GPU_LUTSCALER_0_5x = 7 }
| LUT scalers. More...
enum | GPU_LIGHTLUTSELECT { GPU_LUTSELECT_COMMON = 0 , GPU_LUTSELECT_SP = 1 , GPU_LUTSELECT_DA = 2 }
| LUT selection. More...
enum | GPU_FOGMODE { GPU_NO_FOG = 0 , GPU_FOG = 5 , GPU_GAS = 7 }
| Fog modes. More...
enum | GPU_GASMODE { GPU_PLAIN_DENSITY = 0 , GPU_DEPTH_DENSITY = 1 }
| Gas shading density source values. More...
enum | GPU_GASLUTINPUT { GPU_GAS_DENSITY = 0 , GPU_GAS_LIGHT_FACTOR = 1 }
| Gas color LUT inputs. More...
enum | GPU_Primitive_t { GPU_TRIANGLES = 0x0000 , GPU_TRIANGLE_STRIP = 0x0100 , GPU_TRIANGLE_FAN = 0x0200 , GPU_GEOMETRY_PRIM = 0x0300 }
| Supported primitives. More...
enum | GPU_SHADER_TYPE { GPU_VERTEX_SHADER = 0x0 , GPU_GEOMETRY_SHADER = 0x1 }
| Shader types. More...

## Detailed Description

GPU enumeration values.

## Enumeration Type Documentation

## GPU_BLENDEQUATION

enum GPU_BLENDEQUATION

Blend modes.

Enumerator
GPU_BLEND_ADD | Add colors.
GPU_BLEND_SUBTRACT | Subtract colors.
GPU_BLEND_REVERSE_SUBTRACT | Reverse-subtract colors.
GPU_BLEND_MIN | Use the minimum color.
GPU_BLEND_MAX | Use the maximum color.

## GPU_BLENDFACTOR

enum GPU_BLENDFACTOR

Blend factors.

Enumerator
GPU_ZERO | Zero.
GPU_ONE | One.
GPU_SRC_COLOR | Source color.
GPU_ONE_MINUS_SRC_COLOR | Source color - 1.
GPU_DST_COLOR | Destination color.
GPU_ONE_MINUS_DST_COLOR | Destination color - 1.
GPU_SRC_ALPHA | Source alpha.
GPU_ONE_MINUS_SRC_ALPHA | Source alpha - 1.
GPU_DST_ALPHA | Destination alpha.
GPU_ONE_MINUS_DST_ALPHA | Destination alpha - 1.
GPU_CONSTANT_COLOR | Constant color.
GPU_ONE_MINUS_CONSTANT_COLOR | Constant color - 1.
GPU_CONSTANT_ALPHA | Constant alpha.
GPU_ONE_MINUS_CONSTANT_ALPHA | Constant alpha - 1.
GPU_SRC_ALPHA_SATURATE | Saturated alpha.

## GPU_BUMPMODE

enum GPU_BUMPMODE

Bump map modes.

Enumerator
GPU_BUMP_NOT_USED | Disabled.
GPU_BUMP_AS_BUMP | Bump as bump mapping.
GPU_BUMP_AS_TANG | Bump as tangent/normal mapping.

## GPU_COLORBUF

enum GPU_COLORBUF

Supported color buffer formats.

Enumerator
GPU_RB_RGBA8 | 8-bit Red + 8-bit Green + 8-bit Blue + 8-bit Alpha
GPU_RB_RGB8 | 8-bit Red + 8-bit Green + 8-bit Blue
GPU_RB_RGBA5551 | 5-bit Red + 5-bit Green + 5-bit Blue + 1-bit Alpha
GPU_RB_RGB565 | 5-bit Red + 6-bit Green + 5-bit Blue
GPU_RB_RGBA4 | 4-bit Red + 4-bit Green + 4-bit Blue + 4-bit Alpha

## GPU_COMBINEFUNC

enum GPU_COMBINEFUNC

Texture combiner functions.

Enumerator
GPU_REPLACE | Replace.
GPU_MODULATE | Modulate.
GPU_ADD | Add.
GPU_ADD_SIGNED | Signed add.
GPU_INTERPOLATE | Interpolate.
GPU_SUBTRACT | Subtract.
GPU_DOT3_RGB | Dot3. Scalar result is written to RGB only.
GPU_DOT3_RGBA | Dot3. Scalar result is written to RGBA.
GPU_MULTIPLY_ADD | Multiply then add.
GPU_ADD_MULTIPLY | Add then multiply.

## GPU_CULLMODE

enum GPU_CULLMODE

Cull modes.

Enumerator
GPU_CULL_NONE | Disabled.
GPU_CULL_FRONT_CCW | Front, counter-clockwise.
GPU_CULL_BACK_CCW | Back, counter-clockwise.

## GPU_DEPTHBUF

enum GPU_DEPTHBUF

Supported depth buffer formats.

Enumerator
GPU_RB_DEPTH16 | 16-bit Depth
GPU_RB_DEPTH24 | 24-bit Depth
GPU_RB_DEPTH24_STENCIL8 | 24-bit Depth + 8-bit Stencil

## GPU_EARLYDEPTHFUNC

enum GPU_EARLYDEPTHFUNC

Early depth test functions.

Enumerator
GPU_EARLYDEPTH_GEQUAL | Pass if greater than or equal.
GPU_EARLYDEPTH_GREATER | Pass if greater than.
GPU_EARLYDEPTH_LEQUAL | Pass if less than or equal.
GPU_EARLYDEPTH_LESS | Pass if less than.

## GPU_FOGMODE

enum GPU_FOGMODE

Fog modes.

Enumerator
GPU_NO_FOG | Fog/Gas unit disabled.
GPU_FOG | Fog/Gas unit configured in Fog mode.
GPU_GAS | Fog/Gas unit configured in Gas mode.

## GPU_FORMATS

enum GPU_FORMATS

Supported component formats.

Enumerator
GPU_BYTE | 8-bit byte.
GPU_UNSIGNED_BYTE | 8-bit unsigned byte.
GPU_SHORT | 16-bit short.
GPU_FLOAT | 32-bit float.

## GPU_FRAGOPMODE

enum GPU_FRAGOPMODE

Fragment operation modes.

Enumerator
GPU_FRAGOPMODE_GL | OpenGL mode.
GPU_FRAGOPMODE_GAS_ACC | Gas mode (?).
GPU_FRAGOPMODE_SHADOW | Shadow mode (?).

## GPU_FRESNELSEL

enum GPU_FRESNELSEL

Fresnel options.

Enumerator
GPU_NO_FRESNEL | None.
GPU_PRI_ALPHA_FRESNEL | Primary alpha.
GPU_SEC_ALPHA_FRESNEL | Secondary alpha.
GPU_PRI_SEC_ALPHA_FRESNEL | Primary and secondary alpha.

## GPU_GASDEPTHFUNC

enum GPU_GASDEPTHFUNC

Gas depth functions.

Enumerator
GPU_GAS_NEVER | Never pass (0).
GPU_GAS_ALWAYS | Always pass (1).
GPU_GAS_GREATER | Pass if greater than (1-X).
GPU_GAS_LESS | Pass if less than (X).

## GPU_GASLUTINPUT

enum GPU_GASLUTINPUT

Gas color LUT inputs.

Enumerator
GPU_GAS_DENSITY | Gas density used as input.
GPU_GAS_LIGHT_FACTOR | Light factor used as input.

## GPU_GASMODE

enum GPU_GASMODE

Gas shading density source values.

Enumerator
GPU_PLAIN_DENSITY | Plain density.
GPU_DEPTH_DENSITY | Depth density.

## GPU_LIGHTLUTID

enum GPU_LIGHTLUTID

LUT IDs.

Enumerator
GPU_LUT_D0 | D0 LUT.
GPU_LUT_D1 | D1 LUT.
GPU_LUT_SP | Spotlight LUT.
GPU_LUT_FR | Fresnel LUT.
GPU_LUT_RB | Reflection-Blue LUT.
GPU_LUT_RG | Reflection-Green LUT.
GPU_LUT_RR | Reflection-Red LUT.
GPU_LUT_DA | Distance attenuation LUT.

## GPU_LIGHTLUTINPUT

enum GPU_LIGHTLUTINPUT

LUT inputs.

Enumerator
GPU_LUTINPUT_NH | Normal*HalfVector.
GPU_LUTINPUT_VH | View*HalfVector.
GPU_LUTINPUT_NV | Normal*View.
GPU_LUTINPUT_LN | LightVector*Normal.
GPU_LUTINPUT_SP | -LightVector*SpotlightVector
GPU_LUTINPUT_CP | cosine of phi

## GPU_LIGHTLUTSCALER

enum GPU_LIGHTLUTSCALER

LUT scalers.

Enumerator
GPU_LUTSCALER_1x | 1x scale.
GPU_LUTSCALER_2x | 2x scale.
GPU_LUTSCALER_4x | 4x scale.
GPU_LUTSCALER_8x | 8x scale.
GPU_LUTSCALER_0_25x | 0.25x scale.
GPU_LUTSCALER_0_5x | 0.5x scale.

## GPU_LIGHTLUTSELECT

enum GPU_LIGHTLUTSELECT

LUT selection.

Enumerator
GPU_LUTSELECT_COMMON | LUTs that are common to all lights.
GPU_LUTSELECT_SP | Spotlight LUT.
GPU_LUTSELECT_DA | Distance attenuation LUT.

## GPU_LOGICOP

enum GPU_LOGICOP

Logical operations.

Enumerator
GPU_LOGICOP_CLEAR | Clear.
GPU_LOGICOP_AND | Bitwise AND.
GPU_LOGICOP_AND_REVERSE | Reverse bitwise AND.
GPU_LOGICOP_COPY | Copy.
GPU_LOGICOP_SET | Set.
GPU_LOGICOP_COPY_INVERTED | Inverted copy.
GPU_LOGICOP_NOOP | No operation.
GPU_LOGICOP_INVERT | Invert.
GPU_LOGICOP_NAND | Bitwise NAND.
GPU_LOGICOP_OR | Bitwise OR.
GPU_LOGICOP_NOR | Bitwise NOR.
GPU_LOGICOP_XOR | Bitwise XOR.
GPU_LOGICOP_EQUIV | Equivalent.
GPU_LOGICOP_AND_INVERTED | Inverted bitwise AND.
GPU_LOGICOP_OR_REVERSE | Reverse bitwise OR.
GPU_LOGICOP_OR_INVERTED | Inverted bitwize OR.

## GPU_Primitive_t

enum GPU_Primitive_t

Supported primitives.

Enumerator
GPU_TRIANGLES | Triangles.
GPU_TRIANGLE_STRIP | Triangle strip.
GPU_TRIANGLE_FAN | Triangle fan.
GPU_GEOMETRY_PRIM | Geometry shader primitive.

## GPU_PROCTEX_CLAMP

enum GPU_PROCTEX_CLAMP

Procedural texture clamp modes.

Enumerator
GPU_PT_CLAMP_TO_ZERO | Clamp to zero.
GPU_PT_CLAMP_TO_EDGE | Clamp to edge.
GPU_PT_REPEAT | Symmetrical repeat.
GPU_PT_MIRRORED_REPEAT | Mirrored repeat.
GPU_PT_PULSE | Pulse.

## GPU_PROCTEX_FILTER

enum GPU_PROCTEX_FILTER

Procedural texture filter values.

Enumerator
GPU_PT_NEAREST | Nearest-neighbor.
GPU_PT_LINEAR | Linear interpolation.
GPU_PT_NEAREST_MIP_NEAREST | Nearest-neighbor with mipmap using nearest-neighbor.
GPU_PT_LINEAR_MIP_NEAREST | Linear interpolation with mipmap using nearest-neighbor.
GPU_PT_NEAREST_MIP_LINEAR | Nearest-neighbor with mipmap using linear interpolation.
GPU_PT_LINEAR_MIP_LINEAR | Linear interpolation with mipmap using linear interpolation.

## GPU_PROCTEX_LUTID

enum GPU_PROCTEX_LUTID

Procedural texture LUT IDs.

Enumerator
GPU_LUT_NOISE | Noise table.
GPU_LUT_RGBMAP | RGB mapping function table.
GPU_LUT_ALPHAMAP | Alpha mapping function table.
GPU_LUT_COLOR | Color table.
GPU_LUT_COLORDIF | Color difference table.

## GPU_PROCTEX_MAPFUNC

enum GPU_PROCTEX_MAPFUNC

Procedural texture mapping functions.

Enumerator
GPU_PT_U | U.
GPU_PT_U2 | U2.
GPU_PT_V | V.
GPU_PT_V2 | V2.
GPU_PT_ADD | U+V.
GPU_PT_ADD2 | U2+V2.
GPU_PT_SQRT2 | sqrt(U2+V2)
GPU_PT_MIN | min
GPU_PT_MAX | max
GPU_PT_RMAX | rmax

## GPU_PROCTEX_SHIFT

enum GPU_PROCTEX_SHIFT

Procedural texture shift values.

Enumerator
GPU_PT_NONE | No shift.
GPU_PT_ODD | Odd shift.
GPU_PT_EVEN | Even shift.

## GPU_SCISSORMODE

enum GPU_SCISSORMODE

Scissor test modes.

Enumerator
GPU_SCISSOR_DISABLE | Disable.
GPU_SCISSOR_INVERT | Exclude pixels inside the scissor box.
GPU_SCISSOR_NORMAL | Exclude pixels outside of the scissor box.

## GPU_SHADER_TYPE

enum GPU_SHADER_TYPE

Shader types.

Enumerator
GPU_VERTEX_SHADER | Vertex shader.
GPU_GEOMETRY_SHADER | Geometry shader.

## GPU_STENCILOP

enum GPU_STENCILOP

Stencil operations.

Enumerator
GPU_STENCIL_KEEP | Keep old value. (old_stencil)
GPU_STENCIL_ZERO | Zero. (0)
GPU_STENCIL_REPLACE | Replace value. (ref)
GPU_STENCIL_INCR | Increment value. (old_stencil + 1 saturated to [0, 255])
GPU_STENCIL_DECR | Decrement value. (old_stencil - 1 saturated to [0, 255])
GPU_STENCIL_INVERT | Invert value. (~old_stencil)
GPU_STENCIL_INCR_WRAP | Increment value. (old_stencil + 1)
GPU_STENCIL_DECR_WRAP | Decrement value. (old_stencil - 1)

## GPU_TESTFUNC

enum GPU_TESTFUNC

Test functions.

Enumerator
GPU_NEVER | Never pass.
GPU_ALWAYS | Always pass.
GPU_EQUAL | Pass if equal.
GPU_NOTEQUAL | Pass if not equal.
GPU_LESS | Pass if less than.
GPU_LEQUAL | Pass if less than or equal.
GPU_GREATER | Pass if greater than.
GPU_GEQUAL | Pass if greater than or equal.

## GPU_TEVOP_A

enum GPU_TEVOP_A

Texture Alpha combiner operands.

Enumerator
GPU_TEVOP_A_SRC_ALPHA | Source alpha.
GPU_TEVOP_A_ONE_MINUS_SRC_ALPHA | Source alpha - 1.
GPU_TEVOP_A_SRC_R | Source red.
GPU_TEVOP_A_ONE_MINUS_SRC_R | Source red - 1.
GPU_TEVOP_A_SRC_G | Source green.
GPU_TEVOP_A_ONE_MINUS_SRC_G | Source green - 1.
GPU_TEVOP_A_SRC_B | Source blue.
GPU_TEVOP_A_ONE_MINUS_SRC_B | Source blue - 1.

## GPU_TEVOP_RGB

enum GPU_TEVOP_RGB

Texture RGB combiner operands.

Enumerator
GPU_TEVOP_RGB_SRC_COLOR | Source color.
GPU_TEVOP_RGB_ONE_MINUS_SRC_COLOR | Source color - 1.
GPU_TEVOP_RGB_SRC_ALPHA | Source alpha.
GPU_TEVOP_RGB_ONE_MINUS_SRC_ALPHA | Source alpha - 1.
GPU_TEVOP_RGB_SRC_R | Source red.
GPU_TEVOP_RGB_ONE_MINUS_SRC_R | Source red - 1.
GPU_TEVOP_RGB_0x06 | Unknown.
GPU_TEVOP_RGB_0x07 | Unknown.
GPU_TEVOP_RGB_SRC_G | Source green.
GPU_TEVOP_RGB_ONE_MINUS_SRC_G | Source green - 1.
GPU_TEVOP_RGB_0x0A | Unknown.
GPU_TEVOP_RGB_0x0B | Unknown.
GPU_TEVOP_RGB_SRC_B | Source blue.
GPU_TEVOP_RGB_ONE_MINUS_SRC_B | Source blue - 1.
GPU_TEVOP_RGB_0x0E | Unknown.
GPU_TEVOP_RGB_0x0F | Unknown.

## GPU_TEVSCALE

enum GPU_TEVSCALE

Texture scale factors.

Enumerator
GPU_TEVSCALE_1 | 1x
GPU_TEVSCALE_2 | 2x
GPU_TEVSCALE_4 | 4x

## GPU_TEVSRC

enum GPU_TEVSRC

Texture combiner sources.

Enumerator
GPU_PRIMARY_COLOR | Primary color.
GPU_FRAGMENT_PRIMARY_COLOR | Primary fragment color.
GPU_FRAGMENT_SECONDARY_COLOR | Secondary fragment color.
GPU_TEXTURE0 | Texture unit 0.
GPU_TEXTURE1 | Texture unit 1.
GPU_TEXTURE2 | Texture unit 2.
GPU_TEXTURE3 | Texture unit 3.
GPU_PREVIOUS_BUFFER | Previous buffer.
GPU_CONSTANT | Constant value.
GPU_PREVIOUS | Previous value.

## GPU_TEXCOLOR

enum GPU_TEXCOLOR

Supported texture formats.

Enumerator
GPU_RGBA8 | 8-bit Red + 8-bit Green + 8-bit Blue + 8-bit Alpha
GPU_RGB8 | 8-bit Red + 8-bit Green + 8-bit Blue
GPU_RGBA5551 | 5-bit Red + 5-bit Green + 5-bit Blue + 1-bit Alpha
GPU_RGB565 | 5-bit Red + 6-bit Green + 5-bit Blue
GPU_RGBA4 | 4-bit Red + 4-bit Green + 4-bit Blue + 4-bit Alpha
GPU_LA8 | 8-bit Luminance + 8-bit Alpha
GPU_HILO8 | 8-bit Hi + 8-bit Lo
GPU_L8 | 8-bit Luminance
GPU_A8 | 8-bit Alpha
GPU_LA4 | 4-bit Luminance + 4-bit Alpha
GPU_L4 | 4-bit Luminance
GPU_A4 | 4-bit Alpha
GPU_ETC1 | ETC1 texture compression.
GPU_ETC1A4 | ETC1 texture compression + 4-bit Alpha.

## GPU_TEXFACE

enum GPU_TEXFACE

Texture faces.

Enumerator
GPU_TEXFACE_2D | 2D face
GPU_POSITIVE_X | +X face
GPU_NEGATIVE_X | -X face
GPU_POSITIVE_Y | +Y face
GPU_NEGATIVE_Y | -Y face
GPU_POSITIVE_Z | +Z face
GPU_NEGATIVE_Z | -Z face

## GPU_TEXTURE_FILTER_PARAM

enum GPU_TEXTURE_FILTER_PARAM

Texture filters.

Enumerator
GPU_NEAREST | Nearest-neighbor interpolation.
GPU_LINEAR | Linear interpolation.

## GPU_TEXTURE_MODE_PARAM

enum GPU_TEXTURE_MODE_PARAM

Texture modes.

Enumerator
GPU_TEX_2D | 2D texture
GPU_TEX_CUBE_MAP | Cube map.
GPU_TEX_SHADOW_2D | 2D Shadow texture
GPU_TEX_PROJECTION | Projection texture.
GPU_TEX_SHADOW_CUBE | Shadow cube map.
GPU_TEX_DISABLED | Disabled.

## GPU_TEXTURE_WRAP_PARAM

enum GPU_TEXTURE_WRAP_PARAM

Texture wrap modes.

Enumerator
GPU_CLAMP_TO_EDGE | Clamps to edge.
GPU_CLAMP_TO_BORDER | Clamps to border.
GPU_REPEAT | Repeats texture.
GPU_MIRRORED_REPEAT | Repeats with mirrored texture.

## GPU_TEXUNIT

enum GPU_TEXUNIT

Supported texture units.

Enumerator
GPU_TEXUNIT0 | Texture unit 0.
GPU_TEXUNIT1 | Texture unit 1.
GPU_TEXUNIT2 | Texture unit 2.

## GPU_WRITEMASK

enum GPU_WRITEMASK

Pixel write mask.

Enumerator
GPU_WRITE_RED | Write red.
GPU_WRITE_GREEN | Write green.
GPU_WRITE_BLUE | Write blue.
GPU_WRITE_ALPHA | Write alpha.
GPU_WRITE_DEPTH | Write depth.
GPU_WRITE_COLOR | Write all color components.
GPU_WRITE_ALL | Write all components.